"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const { markdown } = require('markdown');
const extractNodeContent = (node) => {
    return _.slice(node, 2);
};
const extractNodeText = (node) => {
    return _.join(_.flattenDeep(_.map(node, content => {
        if (_.isArray(content)) {
            return extractNodeContent(content);
        }
        return content;
    })), '');
};
const extractTitlesFromTree = (nodes) => {
    return _.reduce(nodes, (accumulator, node) => {
        const nodeType = _.first(node);
        if (nodeType === 'header') {
            const headerContents = extractNodeContent(node);
            accumulator.push(extractNodeText(headerContents));
        }
        if (_.isArray(node)) {
            accumulator = _.union(accumulator, extractTitlesFromTree(node));
        }
        return accumulator;
    }, []);
};
exports.extractTitles = _.flow([markdown.parse, extractTitlesFromTree]);
//# sourceMappingURL=markdown.js.map